#include <iostream>
#include <cmath>
using namespace std;
struct Complexe
{
   double Re;
   double Im;
};




int main ()
{
   Complexe conjugue(Complexe z);
   Complexe addition(const Complexe & z1, const Complexe & z2);
   void affiche(const Complexe & z);
   
   Complexe z1 = {1.,2.};
   Complexe z2 = conjugue(z1);
   Complexe z3;
   z3 = addition(z1,z2);
   affiche(z1); affiche(z2); affiche(z3);
   cout << endl;
}


Complexe addition(const Complexe & z1, const Complexe & z2)
{
   Complexe result;
   result.Re = z1.Re + z2.Re;
   result.Im = z1.Im + z2.Im;
   return result;
}
Complexe conjugue(Complexe z)
{
   z.Im = -z.Im;
   return z;
}
void affiche(const Complexe & z)
{
   cout << z.Re;
   if(z.Im > 0) cout << " + i ";
   else if(z.Im < 0) cout << " - i ";
   if(z.Im) cout << abs(z.Im)<< endl;
}
