#include <iostream>
#include <cstdlib>
#include <cmath>
using namespace std;

int main()
{
  double puissance (const double x, const int a);
  double puissance (const double x, const double a);

  double x = 2.;
  int a1 = -1;
  double a2 = 0.5;
  cout << x <<"^"<< a1 << " = " << puissance(x,a1) << endl;
  cout << x <<"^"<< a2 << " = " << puissance(x,a2) << endl;
  int y = 2;
  cout << y <<"^"<< a1 << " = " << puissance(x,a1) << endl;
  cout << y <<"^"<< a2 << " = " << puissance(x,a2) << endl;
  int y1 = 2.; long int a3 = 2;
  cout << y1 <<"^"<< a3 << " = " << puissance(y1,a3) << endl;
  cout << y1 <<"^"<< a3 << " = " << 
   puissance(static_cast<double>(y1),static_cast<int>(a3)) << endl;
  return 0;   
}

double puissance (const double x, const int a)
{
  double result = 1;
  if(a>0)
    {
      for(int i=0; i<a; i++)
	result *= x;
      cout << "Appel de la fonction puissance (double, int) : ";
      return result;
    }
  else if(x!=0)
    {
      for(int i=0; i<-a; i++)
	result *= 1./x;
      cout << "Appel de la fonction puissance (double, int) : ";
      return result;
    }
  else
    {
      cout << "Appel de la fonction puissance (double, int) : ";
      cout << "Indetermination!!" << endl;
      exit(1);
    }
}

double puissance (const double x, const double a)
{
  if(x>0) 
    {
      cout << "Appel de la fonction puissance (double, double) : ";
      return exp(a*log(x));
    }
  else
    {
      cout << "Appel de la fonction puissance (double, double) : ";
      cout << "Indetermination!!" << endl;
      exit(1);
    }    
}
